// DirDrawView.h : interface of the CDirDrawView class
//
/////////////////////////////////////////////////////////////////////////////

#include "printfvw.h"

class CDirDrawView : public CPrintfView
{
protected: // create from serialization only
	CDirDrawView();
	DECLARE_DYNCREATE(CDirDrawView)

// Attributes
public:
	CDirDrawDoc* GetDocument();

// Operations
public:
	BOOL OnIdle();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDirDrawView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDirDrawView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CDirectDraw* m_pDD;
#ifdef USE_HWND
	HWND m_hwndDD;
#else
	CWnd* m_pWndDD;
#endif
	CDirect3D* m_pD3D;
	C3dStage* m_pStage;
	C3dScene* m_pScene;
	RECT m_rcWnd;
	BOOL m_bEnableUpdates;

	void CleanUp();

// Generated message map functions
protected:
	//{{AFX_MSG(CDirDrawView)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DirDrawView.cpp
inline CDirDrawDoc* CDirDrawView::GetDocument()
   { return (CDirDrawDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
