// printfvw.cpp : implementation file
//

#include "stdafx.h"
#include "printfvw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintfView

IMPLEMENT_DYNCREATE(CPrintfView, CEditView)

CPrintfView::CPrintfView()
{
    m_font.CreateStockObject(ANSI_FIXED_FONT);
    m_iCurrentLine = 0;
}

CPrintfView::~CPrintfView()
{
}


BEGIN_MESSAGE_MAP(CPrintfView, CEditView)
	//{{AFX_MSG_MAP(CPrintfView)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPrintfView drawing

void CPrintfView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CPrintfView diagnostics

#ifdef _DEBUG
void CPrintfView::AssertValid() const
{
	CEditView::AssertValid();
}

void CPrintfView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPrintfView message handlers

int CPrintfView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEditView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	GetEditCtrl().SetReadOnly(TRUE);
    GetEditCtrl().SetFont(&m_font, FALSE);
	
	return 0;
}

void CPrintfView::Print(const char* pszFormat, ...)
{
    char buf[1024];

    // format the text
    vsprintf(buf, pszFormat, (char*)(&pszFormat+1));
    strcat(buf, "\r\n");

    // add the new line to the edit ctrl
    CEdit& ec = GetEditCtrl();
    int iIndex = ec.LineIndex(m_iCurrentLine);
    DWORD dw = MAKELONG(iIndex, iIndex);
    ec.SetSel(dw);
	ec.SendMessage(EM_SCROLLCARET);
    ec.ReplaceSel(buf);
    m_iCurrentLine++;
	GetDocument()->SetModifiedFlag(FALSE);
}

void CPrintfView::Clear()
{
    CEdit& e = GetEditCtrl();
    e.SetWindowText("");
    m_iCurrentLine = 0;
	GetDocument()->SetModifiedFlag(FALSE);
}
